=== debian/changelog ===
bpftrace (0.17.0-2ubuntu1) mantic; urgency=medium

  * Recognize armv7l processor id for the build on armhf.
  * Build with -fpermissive on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 19 Jul 2023 16:08:14 +0200

bpftrace (0.17.0-2) unstable; urgency=medium

  * Recommends libc6-dev. Closes: #1034141.
  * Fix manual page suffixes. Closes: #1034139.
  * Fix lintian overrides about unstripped binaries.

 -- Vincent Bernat <bernat@debian.org>  Mon, 10 Apr 2023 12:59:06 +0200

bpftrace (0.17.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Vincent Bernat ]
  * New upstream release.
  * Use system libbpf.

 -- Vincent Bernat <bernat@debian.org>  Wed, 01 Feb 2023 21:44:04 +0100

bpftrace (0.16.0-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Wed, 31 Aug 2022 15:50:55 +0200

bpftrace (0.15.0-2) unstable; urgency=medium

  * d/control: build-depends on LLVM 14. Closes: #1017674

 -- Vincent Bernat <bernat@debian.org>  Thu, 18 Aug 2022 23:47:45 +0200

bpftrace (0.15.0-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: drop compilation patch.
  * d/rules: also remove empty /usr/share/bpftrace/tools/old.

 -- Vincent Bernat <bernat@debian.org>  Mon, 30 May 2022 09:05:53 +0200

bpftrace (0.14.1-5) unstable; urgency=medium

  * d/control: build-depends on libdw-dev. Closes: #1010849 (really).

 -- Vincent Bernat <bernat@debian.org>  Wed, 11 May 2022 20:19:43 +0200

bpftrace (0.14.1-4) unstable; urgency=medium

  * d/control: build-depends on libdwarf-dev. Closes: #1010849.

 -- Vincent Bernat <bernat@debian.org>  Wed, 11 May 2022 20:08:27 +0200

bpftrace (0.14.1-3) unstable; urgency=medium

  * d/patches: add a patch to fix compilation with libbtf 0.6.0.
    Closes: #1008323.

 -- Vincent Bernat <bernat@debian.org>  Mon, 11 Apr 2022 21:57:34 +0200

bpftrace (0.14.1-2) unstable; urgency=medium

  * d/control: build-depends on systemtap-sdt-dev. Closes: #1005497.
  * d/control: really build-depends on llvm 13 only.

 -- Vincent Bernat <bernat@debian.org>  Tue, 22 Feb 2022 08:05:40 +0100

bpftrace (0.14.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Thu, 30 Dec 2021 13:45:45 +0100

bpftrace (0.14.0-3) unstable; urgency=medium

  * d/control: build-depends on llvm 13. Closes: #1000937.

 -- Vincent Bernat <bernat@debian.org>  Wed, 01 Dec 2021 07:11:21 +0100

bpftrace (0.14.0-2) unstable; urgency=medium

  * d/rules: keep BEGIN/END_trigger symbols when stripping.
    Closes: #995817.

 -- Vincent Bernat <bernat@debian.org>  Mon, 15 Nov 2021 08:15:12 +0100
