## bpftrace 0.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,11 @@
 cmake_minimum_required(VERSION 3.13.0)
 project(bpftrace)
 
+cmake_policy(SET CMP0057 NEW)
+
 # bpftrace version number components.
 set(bpftrace_VERSION_MAJOR 0)
-set(bpftrace_VERSION_MINOR 17)
+set(bpftrace_VERSION_MINOR 19)
 set(bpftrace_VERSION_PATCH 0)
 
 include(GNUInstallDirs)
@@ -108,6 +110,9 @@
 
 include_directories(SYSTEM ${KERNEL_INCLUDE_DIRS})
 
+find_package(ZLIB REQUIRED)
+include_directories(SYSTEM ${ZLIB_INCLUDE_DIRS})
+
 find_package(LibBcc REQUIRED)
 include_directories(SYSTEM ${LIBBCC_INCLUDE_DIRS})
 
@@ -122,7 +127,15 @@
 
 find_package(BISON REQUIRED)
 find_package(FLEX REQUIRED)
-bison_target(bison_parser src/parser.yy ${CMAKE_BINARY_DIR}/parser.tab.cc VERBOSE)
+# `parser_class_name` is deprecated and generates warnings in bison >= 3.3.
+# But `api.parser.class` is not supported in bison < 3.3. So we must inject
+# the %define based on the bison version here.
+if(${BISON_VERSION} VERSION_GREATER_EQUAL 3.3)
+  set(BISON_FLAGS "-Dapi.parser.class={Parser}")
+else()
+  set(BISON_FLAGS "-Dparser_class_name={Parser}")
+endif()
+bison_target(bison_parser src/parser.yy ${CMAKE_BINARY_DIR}/parser.tab.cc COMPILE_FLAGS ${BISON_FLAGS} VERBOSE)
 flex_target(flex_lexer src/lexer.l ${CMAKE_BINARY_DIR}/lex.yy.cc)
 add_flex_bison_dependency(flex_lexer bison_parser)
 add_library(parser ${BISON_bison_parser_OUTPUTS} ${FLEX_flex_lexer_OUTPUTS})
@@ -165,7 +178,7 @@
   endif()
 
   set(MIN_LLVM_MAJOR 6)
-  set(MAX_LLVM_MAJOR 15)
+  set(MAX_LLVM_MAJOR 16)
 
   if((${LLVM_VERSION_MAJOR} VERSION_LESS ${MIN_LLVM_MAJOR}) OR (${LLVM_VERSION_MAJOR} VERSION_GREATER ${MAX_LLVM_MAJOR}))
     message(SEND_ERROR "Unsupported LLVM version found via ${LLVM_INCLUDE_DIRS}: ${LLVM_VERSION_MAJOR}")
