=== src/CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,7 @@
   required_resources.cpp
   struct.cpp
   tracefs.cpp
+  debugfs.cpp
   types.cpp
   usdt.cpp
   utils.cpp
@@ -124,7 +125,7 @@
 endif(STATIC_LINKING)
 
 
-target_link_libraries(runtime ${LIBBPF_LIBRARIES})
+target_link_libraries(runtime ${LIBBPF_LIBRARIES} ${ZLIB_LIBRARIES})
 target_link_libraries(libbpftrace parser resources runtime aot ast arch cxxdemangler_llvm)
 
 if(LIBPCAP_FOUND)
@@ -132,7 +133,7 @@
 endif(LIBPCAP_FOUND)
 
 if(HAVE_BFD_DISASM)
-  if(STATIC_LINKING)
+  if(STATIC_LINKING OR LIBBFD_STATIC)
     add_library(LIBBFD STATIC IMPORTED)
     set_property(TARGET LIBBFD PROPERTY IMPORTED_LOCATION ${LIBBFD_LIBRARIES})
     target_link_libraries(runtime LIBBFD)
@@ -142,10 +143,22 @@
     add_library(LIBIBERTY STATIC IMPORTED)
     set_property(TARGET LIBIBERTY PROPERTY IMPORTED_LOCATION ${LIBIBERTY_LIBRARIES})
     target_link_libraries(runtime LIBIBERTY)
+
+    add_library(LIBZSTD STATIC IMPORTED)
+    if (LIBZSTD_FOUND)
+      set_property(TARGET LIBZSTD PROPERTY IMPORTED_LOCATION ${LIBZSTD_LIBRARIES})
+      target_link_libraries(runtime LIBZSTD)
+    endif(LIBZSTD_FOUND)
+
+    add_library(LIBSFRAME STATIC IMPORTED)
+    if (LIBSFRAME_FOUND)
+      set_property(TARGET LIBSFRAME PROPERTY IMPORTED_LOCATION ${LIBSFRAME_LIBRARIES})
+      target_link_libraries(runtime LIBSFRAME)
+    endif()
   else()
     target_link_libraries(runtime ${LIBBFD_LIBRARIES})
     target_link_libraries(runtime ${LIBOPCODES_LIBRARIES})
-  endif(STATIC_LINKING)
+  endif(STATIC_LINKING OR LIBBFD_STATIC)
 endif(HAVE_BFD_DISASM)
 
 # Link to bcc libraries (without LLVM) if possible
@@ -171,16 +184,28 @@
 if (LIBDW_FOUND)
   if(STATIC_LINKING)
     find_package(LibBz2)
+    find_package(LibLzma)
+    find_package(LibEbl)
+
     add_library(LIBBZ2 STATIC IMPORTED)
     set_property(TARGET LIBBZ2 PROPERTY IMPORTED_LOCATION ${LIBBZ2_LIBRARIES})
 
-    find_package(LibLzma)
     add_library(LIBLZMA STATIC IMPORTED)
     set_property(TARGET LIBLZMA PROPERTY IMPORTED_LOCATION ${LIBLZMA_LIBRARIES})
 
     add_library(LIBDW STATIC IMPORTED)
     set_property(TARGET LIBDW PROPERTY IMPORTED_LOCATION ${LIBDW_LIBRARIES})
-    target_link_libraries(LIBDW INTERFACE LIBBZ2 LIBELF LIBLZMA)
+
+    set(LIBDW_LIBS LIBBZ2 LIBELF LIBLZMA)
+
+    if (${LIBEBL_FOUND})
+      # libebl is not necessary on some systems (e.g. Alpine)
+      add_library(LIBEBL STATIC IMPORTED)
+      set_property(TARGET LIBEBL PROPERTY IMPORTED_LOCATION ${LIBEBL_LIBRARIES})
+      set(LIBDW_LIBS ${LIBDW_LIBS} LIBEBL)
+    endif()
+
+    target_link_libraries(LIBDW INTERFACE ${LIBDW_LIBS})
 
     target_link_libraries(runtime LIBDW)
   else()
@@ -218,11 +243,11 @@
     target_link_libraries(libbpftrace "-Wl,-Bdynamic" "-lrt" "-lpthread" "-ldl" "-lm")
     target_link_libraries(libbpftrace "-Wl,-Bstatic" "-lz")
     target_link_libraries(runtime "-Wl,-Bdynamic" "-lrt" "-lpthread" "-ldl" "-lm")
-    target_link_libraries(runtime "-Wl,-Bstatic" "-lz")  
+    target_link_libraries(runtime "-Wl,-Bstatic" "-lz")
   endif()
 elseif(STATIC_BPF_BCC)
-  # partial static build, libbpf needs zlib
-  target_link_libraries(runtime "-lz")
+  # partial static build, libbpf needs zlib, bcc needs liblzma
+  target_link_libraries(runtime "-lz" "-llzma")
 endif()
 
 unset(MAIN_SRC)
