=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -45,16 +45,9 @@
   ${CODEGEN_SRC}
 )
 
-# Regenerate DWARF data for unit tests
-if (LIBDW_FOUND)
-  find_program(XXD xxd REQUIRED)
-  add_custom_target(testing_debuginfo_data
-          COMMAND
-          ${CMAKE_COMMAND}
-          -DDATA_SOURCE_DIR="${CMAKE_SOURCE_DIR}/tests/data"
-          -P ${CMAKE_SOURCE_DIR}/tests/data/generate_debuginfo_data.cmake)
-  add_dependencies(bpftrace_test testing_debuginfo_data)
-endif()
+add_subdirectory(data)
+add_dependencies(bpftrace_test debuginfo_data)
+target_include_directories(bpftrace_test PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
 
 target_compile_definitions(bpftrace_test PRIVATE TEST_CODEGEN_LOCATION="${CMAKE_SOURCE_DIR}/tests/codegen/llvm/")
 target_link_libraries(bpftrace_test libbpftrace)
