=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,6 @@
 
 %:
 	dh $@
-
-ifeq ($(DEB_HOST_ARCH),armhf)
-  export DEB_CXXFLAGS_MAINT_APPEND=-fpermissive
-endif
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_TESTING:BOOL=OFF -DUSE_SYSTEM_BPF_BCC=1
